Index: pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 63)
+++ pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 64)
@@ -23,5 +23,5 @@
 #include <pjsip/sip_resolve.h>
 #include <pjsip/sip_module.h>
-#include <pjsip/sip_misc.h>
+#include <pjsip/sip_util.h>
 #include <pjsip/sip_errno.h>
 #include <pj/except.h>
@@ -107,11 +107,4 @@
 
 /*
- * Create transaction.
- * Defined in sip_transaction.c
- */
-pj_status_t pjsip_tsx_create( pj_pool_t *pool, pjsip_endpoint *endpt,
-                              pjsip_transaction **tsx );
-
-/*
  * This is the global handler for memory allocation failure, for pools that
  * are created by the endpoint (by default, all pools ARE allocated by 
@@ -295,5 +288,5 @@
  * Get "Allow" header.
  */
-PJ_DECL(const pjsip_allow_hdr*) pjsip_endpt_get_allow_hdr( pjsip_endpoint *endpt )
+PJ_DEF(const pjsip_allow_hdr*) pjsip_endpt_get_allow_hdr( pjsip_endpoint *endpt )
 {
     return endpt->allow_hdr;
@@ -672,5 +665,5 @@
  * Find transaction by the key.
  */
-PJ_DECL(pjsip_transaction*) pjsip_endpt_find_tsx( pjsip_endpoint *endpt,
+PJ_DEF(pjsip_transaction*) pjsip_endpt_find_tsx( pjsip_endpoint *endpt,
 					          const pj_str_t *key )
 {
@@ -981,5 +974,5 @@
  * Find/create transport.
  */
-PJ_DECL(pj_status_t) pjsip_endpt_alloc_transport( pjsip_endpoint *endpt,
+PJ_DEF(pj_status_t) pjsip_endpt_alloc_transport( pjsip_endpoint *endpt,
 						  pjsip_transport_type_e type,
 						  const pj_sockaddr_in *remote,
@@ -992,4 +985,48 @@
 
 
+/*
+ * Report error.
+ */
+PJ_DEF(void) pjsip_endpt_log_error(  pjsip_endpoint *endpt,
+				     const char *sender,
+                                     pj_status_t error_code,
+                                     const char *format,
+                                     ... )
+{
+    char newformat[256];
+    int len;
+    va_list marker;
+
+    va_start(marker, format);
+
+    PJ_UNUSED_ARG(endpt);
+
+    len = pj_native_strlen(format);
+    if (len < sizeof(newformat)-30) {
+	pj_str_t errstr;
+
+	pj_native_strcpy(newformat, format);
+	pj_snprintf(newformat+len, sizeof(newformat)-len-1,
+		    ": [err %d] ", error_code);
+	len += pj_native_strlen(newformat+len);
+
+	errstr = pjsip_strerror(error_code, newformat+len, 
+				sizeof(newformat)-len-1);
+
+	len += errstr.slen;
+	newformat[len] = '\0';
+
+	pj_log(sender, 1, newformat, marker);
+    } else {
+	pj_log(sender, 1, format, marker);
+    }
+
+    va_end(marker);
+}
+
+
+/*
+ * Dump endpoint.
+ */
 PJ_DEF(void) pjsip_endpt_dump( pjsip_endpoint *endpt, pj_bool_t detail )
 {
Index: pjproject/trunk/pjsip/src/pjsip/sip_errno.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_errno.c	(revision 64)
+++ pjproject/trunk/pjsip/src/pjsip/sip_errno.c	(revision 64)
@@ -0,0 +1,125 @@
+/* $Id: $ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+#include <pjsip/sip_errno.h>
+#include <pjsip/sip_msg.h>
+#include <pj/string.h>
+#include <pj/errno.h>
+
+/* PJSIP's own error codes/messages 
+ * MUST KEEP THIS ARRAY SORTED!!
+ */
+static const struct 
+{
+    int code;
+    const char *msg;
+} err_str[] = 
+{
+    /* Generic SIP errors */
+    { PJSIP_EBUSY,		"Object is busy" },
+    { PJSIP_ETYPEEXISTS ,	"Object with the same type exists" },
+
+    /* Messaging errors */
+    { PJSIP_EINVALIDMSG,	"Invalid message/syntax error" },
+    { PJSIP_EINVALIDSCHEME,	"Invalid URI scheme" },
+    { PJSIP_EMSGTOOLONG,	"Message too long" },
+    { PJSIP_EPARTIALMSG,	"Partial message" },
+    { PJSIP_EMISSINGHDR,	"Missing required header(s)" },
+    { PJSIP_EINVALIDVIA,	"Invalid Via header" },
+    { PJSIP_EMULTIPLEVIA,	"Multiple Via headers in response" },
+
+    /* Transport errors */
+    { PJSIP_EUNSUPTRANSPORT,	"Unsupported transport"},
+    { PJSIP_EPENDINGTX,		"Transmit buffer already pending"},
+    { PJSIP_ERXOVERFLOW,	"Rx buffer overflow"},
+
+    /* Transaction errors */
+    { PJSIP_ETSXDESTROYED,	"Transaction has been destroyed"},
+};
+
+
+/*
+ * pjsip_strerror()
+ */
+PJ_DEF(pj_str_t) pjsip_strerror( pj_status_t statcode, 
+				 char *buf, pj_size_t bufsize )
+{
+    pj_str_t errstr;
+
+    if (statcode >= PJSIP_ERRNO_START && statcode < PJSIP_ERRNO_START+800) 
+    {
+	/* Status code. */
+	const pj_str_t *status_text = 
+	    pjsip_get_status_text(PJSIP_ERRNO_TO_SIP_STATUS(statcode));
+
+	errstr.ptr = buf;
+	pj_strncpy_with_null(&errstr, status_text, bufsize);
+	return errstr;
+    }
+    else if (statcode >= PJSIP_ERRNO_START_PJSIP && 
+	     statcode < PJSIP_ERRNO_START_PJSIP + 1000)
+    {
+	/* Find the error in the table.
+	 * Use binary search!
+	 */
+	int first = 0;
+	int n = PJ_ARRAY_SIZE(err_str);
+
+	while (n > 0) {
+	    int half = n/2;
+	    int mid = first + half;
+
+	    if (err_str[mid].code < statcode) {
+		first = mid+1;
+		n -= (half+1);
+	    } else if (err_str[mid].code > statcode) {
+		n = half;
+	    } else {
+		first = mid;
+		break;
+	    }
+	}
+
+
+	if (PJ_ARRAY_SIZE(err_str) && err_str[first].code == statcode) {
+	    pj_str_t msg;
+	    
+	    msg.ptr = (char*)err_str[first].msg;
+	    msg.slen = pj_native_strlen(err_str[first].msg);
+
+	    errstr.ptr = buf;
+	    pj_strncpy_with_null(&errstr, &msg, bufsize);
+	    return errstr;
+
+	} else {
+	    /* Error not found. */
+	    errstr.ptr = buf;
+	    errstr.slen = pj_snprintf(buf, bufsize, 
+				      "Unknown error %d",
+				      statcode);
+
+	    return errstr;
+	}
+    }
+    else {
+	/* Not our code. Give it to PJLIB. */
+	return pj_strerror(statcode, buf, bufsize);
+    }
+
+}
+
Index: pjproject/trunk/pjsip/src/pjsip/sip_parser.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_parser.c	(revision 63)
+++ pjproject/trunk/pjsip/src/pjsip/sip_parser.c	(revision 64)
@@ -24,4 +24,5 @@
 #include <pjsip/sip_transport.h>        /* rdata structure */
 #include <pjlib-util/scanner.h>
+#include <pjlib-util/string.h>
 #include <pj/except.h>
 #include <pj/log.h>
@@ -33,14 +34,18 @@
 #include <pj/assert.h>
 
-#define RESERVED    ";/?:@&=+$,"
-#define MARK	    "-_.!~*'()"
-#define ESCAPED	    "%"
-#define USER	    "&=+$,;?/"
-#define PASS	    "&=+$,"
-#define TOKEN	    "-.!%*_=`'~+"   /* '+' is because of application/pidf+xml
-                                     * in Content-Type! */
-#define HOST	    "_-."
-#define HEX_DIGIT   "abcdefABCDEF"
-#define PARAM_CHAR  "[]/:&+$" MARK "%"
+#define ALNUM
+#define RESERVED	    ";/?:@&=+$,"
+#define MARK		    "-_.!~*'()"
+#define UNRESERVED	    ALNUM MARK
+#define ESCAPED		    "%"
+#define USER_UNRESERVED	    "&=+$,;?/"
+#define PASS		    "&=+$,"
+#define TOKEN		    "-.!%*_=`'~+"   /* '+' is because of app/pidf+xml
+					     * in Content-Type! */
+#define HOST		    "_-."
+#define HEX_DIGIT	    "abcdefABCDEF"
+#define PARAM_CHAR	    "[]/:&+$" UNRESERVED ESCAPED
+#define HNV_UNRESERVED	    "[]/?:+$"
+#define HDR_CHAR	    HNV_UNRESERVED UNRESERVED ESCAPED
 
 #define PJSIP_VERSION		"SIP/2.0"
@@ -93,4 +98,5 @@
 	    pjsip_PARAM_CHAR_SPEC,      /* For scanning pname (or pvalue when
                                          * it's not quoted.) */
+	    pjsip_HDR_CHAR_SPEC,	/* Chars in hname or hvalue */
 	    pjsip_PROBE_USER_HOST_SPEC, /* Hostname characters. */
 	    pjsip_PASSWD_SPEC,	        /* Password. */
@@ -110,4 +116,7 @@
 				     pj_str_t *pname, 
 				     pj_str_t *pvalue);
+static void	    int_parse_hparam( pj_scanner *scanner,
+				      pj_str_t *hname,
+				      pj_str_t *hvalue );
 static void         int_parse_req_line( pj_scanner *scanner, 
 					pj_pool_t *pool,
@@ -272,7 +281,11 @@
     pj_cis_add_str(&pjsip_PARAM_CHAR_SPEC, PARAM_CHAR);
 
+    status = pj_cis_dup(&pjsip_HDR_CHAR_SPEC, &pjsip_ALNUM_SPEC);
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+    pj_cis_add_str(&pjsip_HDR_CHAR_SPEC, HDR_CHAR);
+
     status = pj_cis_dup(&pjsip_USER_SPEC, &pjsip_ALNUM_SPEC);
     PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
-    pj_cis_add_str( &pjsip_USER_SPEC, MARK ESCAPED USER );
+    pj_cis_add_str( &pjsip_USER_SPEC, ESCAPED USER_UNRESERVED );
 
     status = pj_cis_dup(&pjsip_PASSWD_SPEC, &pjsip_ALNUM_SPEC);
@@ -859,4 +872,5 @@
     /* pname */
     pj_scan_get(scanner, &pjsip_PARAM_CHAR_SPEC, pname);
+    pj_str_unescape(pname);
 
     /* pvalue, if any */
@@ -872,4 +886,5 @@
 	} else {
 	    pj_scan_get(scanner, &pjsip_PARAM_CHAR_SPEC, pvalue);
+	    pj_str_unescape(pvalue);
 	}
     } else {
@@ -890,4 +905,26 @@
 }
 
+/* Parse header parameter. */
+static void int_parse_hparam( pj_scanner *scanner,
+			      pj_str_t *hname, pj_str_t *hvalue )
+{
+    /* Get '?' or '&' character. */
+    pj_scan_get_char(scanner);
+
+    /* hname */
+    pj_scan_get(scanner, &pjsip_HDR_CHAR_SPEC, hname);
+    pj_str_unescape(hname);
+
+    /* pvalue, if any */
+    if (*scanner->curptr == '=') {
+	pj_scan_get_char(scanner);
+	pj_scan_get(scanner, &pjsip_HDR_CHAR_SPEC, hvalue);
+	pj_str_unescape(hvalue);
+    } else {
+	hvalue->ptr = NULL;
+	hvalue->slen = 0;
+    }
+}
+
 /* Parse host:port in URI. */
 static void int_parse_uri_host_port( pj_scanner *scanner, 
@@ -895,8 +932,10 @@
 {
     pj_scan_get( scanner, &pjsip_HOST_SPEC, host);
+    /* RFC3261 section 19.1.2: host don't need to be unescaped */
     if (*scanner->curptr == ':') {
 	pj_str_t port;
 	pj_scan_get_char(scanner);
 	pj_scan_get(scanner, &pjsip_DIGIT_SPEC, &port);
+	pj_str_unescape(&port);
 	*p_port = pj_strtoul(&port);
     } else {
@@ -927,7 +966,10 @@
 {
     pj_scan_get( scanner, &pjsip_USER_SPEC, user);
+    pj_str_unescape(user);
+
     if ( *scanner->curptr == ':') {
 	pj_scan_get_char( scanner );
 	pj_scan_get( scanner, &pjsip_PASSWD_SPEC, pass);
+	pj_str_unescape(pass);
     } else {
 	pass->ptr = NULL;
@@ -945,4 +987,7 @@
     pjsip_uri *uri;
     int is_name_addr = 0;
+
+    /* Exhaust any whitespaces. */
+    pj_scan_skip_whitespace(scanner);
 
     if (*scanner->curptr=='"' || *scanner->curptr=='<') {
@@ -1035,4 +1080,5 @@
     int colon;
     int skip_ws = scanner->skip_ws;
+    int hsep = '?';
     scanner->skip_ws = 0;
 
@@ -1090,12 +1136,18 @@
 
 	} else {
-	    concat_param(&url->other_param, pool, &pname, &pvalue);
+	    pjsip_param *p = pj_pool_alloc(pool, sizeof(pjsip_param));
+	    p->name = pname;
+	    p->value = pvalue;
+	    pj_list_insert_before(&url->other_param, p);
 	}
     }
 
     /* Get header params. */
-    if (parse_params && *scanner->curptr == '?') {
-	pj_scan_get_until(scanner, &pjsip_NEWLINE_OR_EOF_SPEC, 
-                          &url->header_param);
+    while (parse_params && *scanner->curptr == hsep) {
+	pjsip_param *param;
+	param = pj_pool_alloc(pool, sizeof(pjsip_param));
+	int_parse_hparam(scanner, &param->name, &param->value);
+	pj_list_insert_before(&url->header_param, param);
+	hsep = '&';
     }
 
Index: pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 63)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 64)
@@ -20,5 +20,5 @@
 #include <pjsip/sip_transport.h>
 #include <pjsip/sip_config.h>
-#include <pjsip/sip_misc.h>
+#include <pjsip/sip_util.h>
 #include <pjsip/sip_event.h>
 #include <pjsip/sip_endpoint.h>
@@ -346,7 +346,7 @@
  * Create new transaction.
  */
-pj_status_t pjsip_tsx_create( pj_pool_t *pool,
-			      pjsip_endpoint *endpt,
-                              pjsip_transaction **p_tsx)
+PJ_DEF(pj_status_t) pjsip_tsx_create( pj_pool_t *pool,
+				      pjsip_endpoint *endpt,
+				      pjsip_transaction **p_tsx)
 {
     pjsip_transaction *tsx;
Index: pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 63)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 64)
@@ -648,5 +648,5 @@
 	    if (msg_status != PJ_SUCCESS) {
 		if (remaining_len == PJSIP_MAX_PKT_LEN) {
-		    mgr->msg_cb(mgr->endpt, PJSIP_EOVERFLOW, rdata);
+		    mgr->msg_cb(mgr->endpt, PJSIP_ERXOVERFLOW, rdata);
 		    /* Exhaust all data. */
 		    return rdata->pkt_info.len;
Index: pjproject/trunk/pjsip/src/pjsip/sip_uri.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_uri.c	(revision 63)
+++ pjproject/trunk/pjsip/src/pjsip/sip_uri.c	(revision 64)
@@ -19,9 +19,57 @@
 #include <pjsip/sip_uri.h>
 #include <pjsip/sip_msg.h>
+#include <pjsip/sip_parser.h>
 #include <pjsip/print_util.h>
+#include <pjsip/sip_errno.h>
+#include <pjlib-util/string.h>
 #include <pj/string.h>
 #include <pj/pool.h>
 #include <pj/assert.h>
 
+/*
+ * Generic parameter manipulation.
+ */
+PJ_DEF(pjsip_param*) pjsip_param_find(  pjsip_param *param_list,
+					const pj_str_t *name )
+{
+    pjsip_param *p = param_list->next;
+    while (p != param_list) {
+	if (pj_stricmp(&p->name, name)==0)
+	    return p;
+	p = p->next;
+    }
+    return NULL;
+}
+
+PJ_DEF(const pjsip_param*) pjsip_param_cfind( const pjsip_param *param_list,
+					      const pj_str_t *name )
+{
+    const pjsip_param *p = param_list->next;
+    while (p != param_list) {
+	if (pj_stricmp(&p->name, name)==0)
+	    return p;
+	p = p->next;
+    }
+    return NULL;
+}
+
+PJ_DEF(void) pjsip_param_clone( pj_pool_t *pool, pjsip_param *dst_list,
+				const pjsip_param *src_list)
+{
+    const pjsip_param *p = src_list->next;
+
+    pj_list_init(dst_list);
+    while (p != src_list) {
+	pjsip_param *new_param = pj_pool_alloc(pool, sizeof(pjsip_param));
+	pj_strdup(pool, &new_param->name, &p->name);
+	pj_strdup(pool, &new_param->value, &p->value);
+	pj_list_insert_before(dst_list, new_param);
+	p = p->next;
+    }
+}
+
+/*
+ * URI stuffs
+ */
 #define IS_SIPS(url)	((url)->vptr==&sips_url_vptr)
 
@@ -110,4 +158,6 @@
     url->ttl_param = -1;
     url->vptr = secure ? &sips_url_vptr : &sip_url_vptr;
+    pj_list_init(&url->other_param);
+    pj_list_init(&url->header_param);
 }
 
@@ -124,35 +174,23 @@
 {
     int printed;
-    pj_size_t size_required;
     char *startbuf = buf;
+    char *endbuf = buf+size;
     const pj_str_t *scheme;
+    pjsip_param *param;
+    char hparam_char = '?';
+
     *buf = '\0';
-
-    /* Check the buffer length. */
-    size_required = 6 + url->host.slen + 10 +
-		    url->user.slen + url->passwd.slen + 2 +
-		    url->user_param.slen + 6 +
-		    url->method_param.slen + 8 +
-		    url->transport_param.slen + 11 +
-		    9 + 5 +
-		    url->maddr_param.slen + 7 +
-		    3 +
-		    url->other_param.slen +
-		    url->header_param.slen;
-    if (size < size_required) {
-	return -1;
-    }
 
     /* Print scheme ("sip:" or "sips:") */
     scheme = pjsip_uri_get_scheme(url);
-    copy_advance_no_check(buf, *scheme);
+    copy_advance_check(buf, *scheme);
     *buf++ = ':';
 
     /* Print "user:password@", if any. */
     if (url->user.slen) {
-	copy_advance_no_check(buf, url->user);
+	copy_advance_escape(buf, url->user, pjsip_USER_SPEC);
 	if (url->passwd.slen) {
 	    *buf++ = ':';
-	    copy_advance_no_check(buf, url->passwd);
+	    copy_advance_escape(buf, url->passwd, pjsip_PASSWD_SPEC);
 	}
 
@@ -162,5 +200,5 @@
     /* Print host. */
     pj_assert(url->host.slen != 0);
-    copy_advance_no_check(buf, url->host);
+    copy_advance_check(buf, url->host);
 
     /* Only print port if it is explicitly specified. 
@@ -171,6 +209,6 @@
      * UA has sent us port, so we'll just send the port indiscrimately
      */
-    PJ_TODO(SHOULD_DISALLOW_URI_PORT_IN_FROM_TO_HEADER)
-    if (url->port /*&& context != PJSIP_URI_IN_FROMTO_HDR*/) {
+    //PJ_TODO(SHOULD_DISALLOW_URI_PORT_IN_FROM_TO_HEADER)
+    if (url->port && context != PJSIP_URI_IN_FROMTO_HDR) {
 	*buf++ = ':';
 	printed = pj_utoa(url->port, buf);
@@ -179,19 +217,21 @@
 
     /* User param is allowed in all contexes */
-    copy_advance_pair_no_check(buf, ";user=", 6, url->user_param);
+    copy_advance_pair_check(buf, ";user=", 6, url->user_param);
 
     /* Method param is only allowed in external/other context. */
     if (context == PJSIP_URI_IN_OTHER) {
-	copy_advance_pair_no_check(buf, ";method=", 8, url->method_param);
+	copy_advance_pair_escape(buf, ";method=", 8, url->method_param, 
+				 pjsip_PARAM_CHAR_SPEC);
     }
 
     /* Transport is not allowed in From/To header. */
     if (context != PJSIP_URI_IN_FROMTO_HDR) {
-	copy_advance_pair_no_check(buf, ";transport=", 11, url->transport_param);
+	copy_advance_pair_escape(buf, ";transport=", 11, url->transport_param,
+				 pjsip_PARAM_CHAR_SPEC);
     }
 
     /* TTL param is not allowed in From, To, Route, and Record-Route header. */
     if (url->ttl_param >= 0 && context != PJSIP_URI_IN_FROMTO_HDR &&
-	context != PJSIP_URI_IN_ROUTING_HDR) 
+	context != PJSIP_URI_IN_ROUTING_HDR && (endbuf-buf) > 15) 
     {
 	pj_memcpy(buf, ";ttl=", 5);
@@ -202,5 +242,6 @@
     /* maddr param is not allowed in From and To header. */
     if (context != PJSIP_URI_IN_FROMTO_HDR) {
-	copy_advance_pair_no_check(buf, ";maddr=", 7, url->maddr_param);
+	copy_advance_pair_escape(buf, ";maddr=", 7, url->maddr_param,
+				 pjsip_PARAM_CHAR_SPEC);
     }
 
@@ -210,15 +251,30 @@
     {
 	pj_str_t lr = { ";lr", 3 };
-	copy_advance_no_check(buf, lr);
+	copy_advance_check(buf, lr);
     }
 
     /* Other param. */
-    if (url->other_param.slen) {
-	copy_advance_no_check(buf, url->other_param);
+    param = url->other_param.next;
+    while (param != &url->other_param) {
+	*buf++ = ';';
+	copy_advance_escape(buf, param->name, pjsip_PARAM_CHAR_SPEC);
+	if (param->value.slen) {
+	    *buf++ = '=';
+	    copy_advance_escape(buf, param->value, pjsip_PARAM_CHAR_SPEC);
+	}
+	param = param->next;
     }
 
     /* Header param. */
-    if (url->header_param.slen) {
-	copy_advance_no_check(buf, url->header_param);
+    param = url->header_param.next;
+    while (param != &url->header_param) {
+	*buf++ = hparam_char;
+	copy_advance_escape(buf, param->name, pjsip_HDR_CHAR_SPEC);
+	if (param->value.slen) {
+	    *buf++ = '=';
+	    copy_advance_escape(buf, param->value, pjsip_HDR_CHAR_SPEC);
+	}
+	param = param->next;
+	hparam_char = '&';
     }
 
@@ -227,67 +283,132 @@
 }
 
-static int pjsip_url_compare( pjsip_uri_context_e context,
-			      const pjsip_url *url1, const pjsip_url *url2)
-{
-    /* The easiest (and probably the most efficient) way to compare two URLs
-       are to print them, and compare them bytes per bytes. This technique
-       works quite well with RFC3261, as the RFC (unlike RFC2543) defines that
-       components specified in one URL does NOT match its default value if
-       it is not specified in the second URL. For example, parameter "user=ip"
-       does NOT match if it is omited in second URL.
-
-       HOWEVER, THE SAME CAN NOT BE APPLIED FOR other-param NOR header-param.
-       For these, each of the parameters must be compared one by one. Parameter
-       that exists in one URL will match the comparison. But parameter that
-       exists in both URLs and doesn't match wont match the URL comparison.
-
-       The solution for this is to compare 'standard' URL components with
-       bytes-to-bytes comparison, and compare other-param and header-param with
-       more intelligent comparison.
-     */
-    char str_url1[PJSIP_MAX_URL_SIZE];
-    char str_url2[PJSIP_MAX_URL_SIZE];
-    int len1, len2;
-
-    /* Must compare scheme first, as the second URI may not be SIP URL. */
-    if (pj_stricmp(pjsip_uri_get_scheme(url1), pjsip_uri_get_scheme(url2)))
-	return -1;
-
-    len1 = pjsip_url_print(context, url1, str_url1, sizeof(str_url1));
-    if (len1 < 1) {
-	pj_assert(0);
-	return -1;
-    }
-    len2 = pjsip_url_print(context, url2, str_url2, sizeof(str_url2));
-    if (len2 < 1) {
-	pj_assert(0);
-	return -1;
-    }
-
-    if (len1 != len2) {
-	/* Not equal. */
-	return -1;
-    }
-
-    if (pj_native_strcmp(str_url1, str_url2)) {
-	/* Not equal */
-	return -1;
-    }
-
-    /* TODO: compare other-param and header-param in more intelligent manner. */
-    PJ_TODO(HPARAM_AND_OTHER_PARAM_COMPARISON_IN_URL_COMPARISON)
-
-    if (pj_strcmp(&url1->other_param, &url2->other_param)) {
-	/* Not equal. */
-	return -1;
-    }
-    if (pj_strcmp(&url1->header_param, &url2->header_param)) {
-	/* Not equal. */
-	return -1;
-    }
-
-    /* Seems to be equal, isn't it. */
-    return 0;
+static pj_status_t pjsip_url_compare( pjsip_uri_context_e context,
+				      const pjsip_url *url1, 
+				      const pjsip_url *url2)
+{
+    const pjsip_param *p1;
+
+    /*
+     * Compare two SIP URL's according to Section 19.1.4 of RFC 3261.
+     */
+
+    /* SIP and SIPS URI are never equivalent. 
+     * Note: just compare the vptr to avoid string comparison. 
+     *       Pretty neat huh!!
+     */
+    if (url1->vptr != url2->vptr)
+	return PJSIP_ECMPSCHEME;
+
+    /* Comparison of the userinfo of SIP and SIPS URIs is case-sensitive. 
+     * This includes userinfo containing passwords or formatted as 
+     * telephone-subscribers.
+     */
+    if (pj_strcmp(&url1->user, &url2->user) != 0)
+	return PJSIP_ECMPUSER;
+    if (pj_strcmp(&url1->passwd, &url2->passwd) != 0)
+	return PJSIP_ECMPPASSWD;
     
+    /* Comparison of all other components of the URI is
+     * case-insensitive unless explicitly defined otherwise.
+     */
+
+    /* The ordering of parameters and header fields is not significant 
+     * in comparing SIP and SIPS URIs.
+     */
+
+    /* Characters other than those in the reserved set (see RFC 2396 [5])
+     * are equivalent to their encoding.
+     */
+
+    /* An IP address that is the result of a DNS lookup of a host name 
+     * does not match that host name.
+     */
+    if (pj_stricmp(&url1->host, &url2->host) != 0)
+	return PJSIP_ECMPHOST;
+
+    /* A URI omitting any component with a default value will not match a URI
+     * explicitly containing that component with its default value. 
+     * For instance, a URI omitting the optional port component will not match
+     * a URI explicitly declaring port 5060. 
+     * The same is true for the transport-parameter, ttl-parameter, 
+     * user-parameter, and method components.
+     */
+
+    /* Port is not allowed in To and From header.
+     */
+    if (context != PJSIP_URI_IN_FROMTO_HDR) {
+	if (url1->port != url2->port)
+	    return PJSIP_ECMPPORT;
+    }
+    /* Transport is not allowed in From/To header. */
+    if (context != PJSIP_URI_IN_FROMTO_HDR) {
+	if (pj_stricmp(&url1->transport_param, &url2->transport_param) != 0)
+	    return PJSIP_ECMPTRANSPORTPRM;
+    }
+    /* TTL param is not allowed in From, To, Route, and Record-Route header. */
+    if (context != PJSIP_URI_IN_FROMTO_HDR &&
+	context != PJSIP_URI_IN_ROUTING_HDR)
+    {
+	if (url1->ttl_param != url2->ttl_param)
+	    return PJSIP_ECMPTTLPARAM;
+    }
+    /* User param is allowed in all contexes */
+    if (pj_stricmp(&url1->user_param, &url2->user_param) != 0)
+	return PJSIP_ECMPUSERPARAM;
+    /* Method param is only allowed in external/other context. */
+    if (context == PJSIP_URI_IN_OTHER) {
+	if (pj_stricmp(&url1->method_param, &url2->method_param) != 0)
+	    return PJSIP_ECMPMETHODPARAM;
+    }
+    /* maddr param is not allowed in From and To header. */
+    if (context != PJSIP_URI_IN_FROMTO_HDR) {
+	if (pj_stricmp(&url1->maddr_param, &url2->maddr_param) != 0)
+	    return PJSIP_ECMPMADDRPARAM;
+    }
+
+    /* lr parameter is ignored (?) */
+    /* lr param is not allowed in From, To, and Contact header. */
+
+
+    /* All other uri-parameters appearing in only one URI are ignored when 
+     * comparing the URIs.
+     */
+    p1 = url1->other_param.next;
+    while (p1 != &url1->other_param) {
+	const pjsip_param *p2;
+	p2 = pjsip_param_cfind(&url2->other_param, &p1->name);
+	if (p2 ) {
+	    if (pj_stricmp(&p1->value, &p2->value) != 0)
+		return PJSIP_ECMPOTHERPARAM;
+	}
+
+	p1 = p1->next;
+    }
+
+    /* URI header components are never ignored. Any present header component
+     * MUST be present in both URIs and match for the URIs to match. 
+     * The matching rules are defined for each header field in Section 20.
+     */
+    p1 = url1->header_param.next;
+    while (p1 != &url1->header_param) {
+	const pjsip_param *p2;
+	p2 = pjsip_param_cfind(&url2->header_param, &p1->name);
+	if (p2) {
+	    /* It seems too much to compare two header params according to
+	     * the rule of each header. We'll just compare them string to
+	     * string..
+	     */
+	    PJ_TODO(MORE_COMPLIANT_HEADER_PARAM_COMPARISON_IN_URL);
+
+	    if (pj_stricmp(&p1->value, &p2->value) != 0)
+		return PJSIP_ECMPHEADERPARAM;
+	} else {
+	    return PJSIP_ECMPHEADERPARAM;
+	}
+	p1 = p1->next;
+    }
+
+    /* Equal!! Pheuww.. */
+    return PJ_SUCCESS;
 }
 
@@ -305,6 +426,6 @@
     url->ttl_param = rhs->ttl_param;
     pj_strdup( pool, &url->maddr_param, &rhs->maddr_param);
-    pj_strdup( pool, &url->other_param, &rhs->other_param);
-    pj_strdup( pool, &url->header_param, &rhs->header_param);
+    pjsip_param_clone(pool, &url->other_param, &rhs->other_param);
+    pjsip_param_clone(pool, &url->header_param, &rhs->header_param);
     url->lr_param = rhs->lr_param;
 }
